// --------------------------------------------------------
// Staudamm problem
// --------------------------------------------------------
// -   produced by the Staudamm-Producer                       -
// -   version 1                                          -
// --------------------------------------------------------
// --------------------------------------------------------
// System Parameters 
// --------------------------------------------------------



#define main_thr 50
#define maxlevel 100
#define buffer 0
#define lr 1
#define hr 3
#define mininflow 3
#define maxinflow 4
#define main_dur 50
process count=4;

global synchronizer high, low, off;
local discrete c:0...main_thr;
local dense m;
local dense water;

/* values of parameters are set in .d.risk file */

parameter step0;
parameter gap0;

parameter step1;
parameter gap1;

parameter step2;
parameter gap2;

/* automaton ctrl */
mode zlll (water<=buffer+step0) {
  rate water:[mininflow-3*lr-0*hr, maxinflow-3*lr-0*hr];
  when !high@(2) (water>=buffer+step0) may goto zHll;
}
mode zHll (buffer+step0-gap0<=water and water<=buffer+step0+step0) {
  rate water:[mininflow-2*lr-1*hr, maxinflow-2*lr-1*hr];
  when !high@(3) (water>=buffer+step0+step0) may goto zHHl;
  when !low@(2) (buffer+step0-gap0>=water) may goto zlll;
  when !off@(2) (buffer+step0-gap0>=water) may goto zxll;
}
mode zxll (m@(2)<=main_dur and water<=buffer+step1) {
  rate water:[mininflow-2*lr-0*hr, maxinflow-2*lr-0*hr];
  when !low@(2) (m@(2)>=main_dur and  water<buffer+step0) may goto zlll;
  when !high@(2) (m@(2)>=main_dur and  water>=buffer+step0) may goto zHll;
  when !high@(3) (m@(2)<main_dur and water>=buffer+step1) may goto zxHl;
}
mode zlHl (buffer+step0-gap0<=water and water<=buffer+step0+step0) {
  rate water:[mininflow-2*lr-1*hr, maxinflow-2*lr-1*hr];
  when !high@(2) (water>=buffer+step0+step0) may goto zHHl;
  when !low@(3) (buffer+step0-gap0>=water) may goto zlll;
  when !off@(3) (buffer+step0-gap0>=water) may goto zlxl;
}
mode zHHl (buffer+step0+step0-gap0<=water and water<=buffer+step0+step0+step0) {
  rate water:[mininflow-1*lr-2*hr, maxinflow-1*lr-2*hr];
  when !high@(4) (water>=buffer+step0+step0+step0) may goto zHHH;
  when !low@(3) (buffer+step0+step0-gap0>=water) may goto zHll;
  when !off@(3) (buffer+step0+step0-gap0>=water) may goto zHxl;
}
mode zxHl (m@(2)<=main_dur and buffer+step1-gap1<=water and water<=buffer+step1+step1) {
  rate water:[mininflow-1*lr-1*hr, maxinflow-1*lr-1*hr];
  when !low@(2) (m@(2)>=main_dur and  water<buffer+step0+step0) may goto zlHl;
  when !high@(2) (m@(2)>=main_dur and  water>=buffer+step0+step0) may goto zHHl;
  when !high@(4) (m@(2)<main_dur and water>=buffer+step1+step1) may goto zxHH;
  when !low@(3) (m@(2)<main_dur and buffer+step1-gap1>=water) may goto zxll;
  when !off@(3) (m@(2)<main_dur and buffer+step1-gap1>=water) may goto zxxl;
}
mode zlxl (m@(3)<=main_dur and water<=buffer+step1) {
  rate water:[mininflow-2*lr-0*hr, maxinflow-2*lr-0*hr];
  when !low@(3) (m@(3)>=main_dur and  water<buffer+step0) may goto zlll;
  when !high@(3) (m@(3)>=main_dur and  water>=buffer+step0) may goto zlHl;
  when !high@(2) (m@(3)<main_dur and water>=buffer+step1) may goto zHxl;
}
mode zHxl (m@(3)<=main_dur and buffer+step1-gap1<=water and water<=buffer+step1+step1) {
  rate water:[mininflow-1*lr-1*hr, maxinflow-1*lr-1*hr];
  when !low@(3) (m@(3)>=main_dur and  water<buffer+step0+step0) may goto zHll;
  when !high@(3) (m@(3)>=main_dur and  water>=buffer+step0+step0) may goto zHHl;
  when !high@(4) (m@(3)<main_dur and water>=buffer+step1+step1) may goto zHxH;
  when !low@(2) (m@(3)<main_dur and buffer+step1-gap1>=water) may goto zlxl;
  when !off@(2) (m@(3)<main_dur and buffer+step1-gap1>=water) may goto zxxl;
}
mode zxxl (m@(2)<=main_dur and m@(3)<=main_dur and water<=buffer+step2) {
  rate water:[mininflow-1*lr-0*hr, maxinflow-1*lr-0*hr];
  when !low@(2) (m@(2)>=main_dur and  water<buffer+step1) may goto zlxl;
  when !high@(2) (m@(2)>=main_dur and  water>=buffer+step1) may goto zHxl;
  when !low@(3) (m@(2)<main_dur and m@(3)>=main_dur and  water<buffer+step1) may goto zxll;
  when !high@(3) (m@(2)<main_dur and m@(3)>=main_dur and  water>=buffer+step1) may goto zxHl;
  when !high@(4) (m@(2)<main_dur and m@(3)<main_dur and water>=buffer+step2) may goto zxxH;
}
mode zllH (buffer+step0-gap0<=water and water<=buffer+step0+step0) {
  rate water:[mininflow-2*lr-1*hr, maxinflow-2*lr-1*hr];
  when !high@(2) (water>=buffer+step0+step0) may goto zHlH;
  when !low@(4) (buffer+step0-gap0>=water) may goto zlll;
  when !off@(4) (buffer+step0-gap0>=water) may goto zllx;
}
mode zHlH (buffer+step0+step0-gap0<=water and water<=buffer+step0+step0+step0) {
  rate water:[mininflow-1*lr-2*hr, maxinflow-1*lr-2*hr];
  when !high@(3) (water>=buffer+step0+step0+step0) may goto zHHH;
  when !low@(4) (buffer+step0+step0-gap0>=water) may goto zHll;
  when !off@(4) (buffer+step0+step0-gap0>=water) may goto zHlx;
}
mode zxlH (m@(2)<=main_dur and buffer+step1-gap1<=water and water<=buffer+step1+step1) {
  rate water:[mininflow-1*lr-1*hr, maxinflow-1*lr-1*hr];
  when !low@(2) (m@(2)>=main_dur and  water<buffer+step0+step0) may goto zllH;
  when !high@(2) (m@(2)>=main_dur and  water>=buffer+step0+step0) may goto zHlH;
  when !high@(3) (m@(2)<main_dur and water>=buffer+step1+step1) may goto zxHH;
  when !low@(4) (m@(2)<main_dur and buffer+step1-gap1>=water) may goto zxll;
  when !off@(4) (m@(2)<main_dur and buffer+step1-gap1>=water) may goto zxlx;
}
mode zlHH (buffer+step0+step0-gap0<=water and water<=buffer+step0+step0+step0) {
  rate water:[mininflow-1*lr-2*hr, maxinflow-1*lr-2*hr];
  when !high@(2) (water>=buffer+step0+step0+step0) may goto zHHH;
  when !low@(4) (buffer+step0+step0-gap0>=water) may goto zlHl;
  when !off@(4) (buffer+step0+step0-gap0>=water) may goto zlHx;
}
mode zHHH (buffer+step0+step0+step0-gap0<=water) {
  rate water:[mininflow-0*lr-3*hr, maxinflow-0*lr-3*hr];
  when !low@(4) (buffer+step0+step0+step0-gap0>=water) may goto zHHl;
  when !off@(4) (buffer+step0+step0+step0-gap0>=water) may goto zHHx;
}
mode zxHH (m@(2)<=main_dur and buffer+step1+step1-gap1<=water) {
  rate water:[mininflow-0*lr-2*hr, maxinflow-0*lr-2*hr];
  when !low@(2) (m@(2)>=main_dur and  water<buffer+step0+step0+step0) may goto zlHH;
  when !high@(2) (m@(2)>=main_dur and  water>=buffer+step0+step0+step0) may goto zHHH;
  when !low@(4) (m@(2)<main_dur and buffer+step1+step1-gap1>=water) may goto zxHl;
  when !off@(4) (m@(2)<main_dur and buffer+step1+step1-gap1>=water) may goto zxHx;
}
mode zlxH (m@(3)<=main_dur and buffer+step1-gap1<=water and water<=buffer+step1+step1) {
  rate water:[mininflow-1*lr-1*hr, maxinflow-1*lr-1*hr];
  when !low@(3) (m@(3)>=main_dur and  water<buffer+step0+step0) may goto zllH;
  when !high@(3) (m@(3)>=main_dur and  water>=buffer+step0+step0) may goto zlHH;
  when !high@(2) (m@(3)<main_dur and water>=buffer+step1+step1) may goto zHxH;
  when !low@(4) (m@(3)<main_dur and buffer+step1-gap1>=water) may goto zlxl;
  when !off@(4) (m@(3)<main_dur and buffer+step1-gap1>=water) may goto zlxx;
}
mode zHxH (m@(3)<=main_dur and buffer+step1+step1-gap1<=water) {
  rate water:[mininflow-0*lr-2*hr, maxinflow-0*lr-2*hr];
  when !low@(3) (m@(3)>=main_dur and  water<buffer+step0+step0+step0) may goto zHlH;
  when !high@(3) (m@(3)>=main_dur and  water>=buffer+step0+step0+step0) may goto zHHH;
  when !low@(4) (m@(3)<main_dur and buffer+step1+step1-gap1>=water) may goto zHxl;
  when !off@(4) (m@(3)<main_dur and buffer+step1+step1-gap1>=water) may goto zHxx;
}
mode zxxH (m@(2)<=main_dur and m@(3)<=main_dur and buffer+step2-gap2<=water) {
  rate water:[mininflow-0*lr-1*hr, maxinflow-0*lr-1*hr];
  when !low@(2) (m@(2)>=main_dur and  water<buffer+step1+step1) may goto zlxH;
  when !high@(2) (m@(2)>=main_dur and  water>=buffer+step1+step1) may goto zHxH;
  when !low@(3) (m@(2)<main_dur and m@(3)>=main_dur and  water<buffer+step1+step1) may goto zxlH;
  when !high@(3) (m@(2)<main_dur and m@(3)>=main_dur and  water>=buffer+step1+step1) may goto zxHH;
  when !low@(4) (m@(2)<main_dur and m@(3)<main_dur and buffer+step2-gap2>=water) may goto zxxl;
  when !off@(4) (m@(2)<main_dur and m@(3)<main_dur and buffer+step2-gap2>=water) may goto zxxx;
}
mode zllx (m@(4)<=main_dur and water<=buffer+step1) {
  rate water:[mininflow-2*lr-0*hr, maxinflow-2*lr-0*hr];
  when !low@(4) (m@(4)>=main_dur and  water<buffer+step0) may goto zlll;
  when !high@(4) (m@(4)>=main_dur and  water>=buffer+step0) may goto zllH;
  when !high@(2) (m@(4)<main_dur and water>=buffer+step1) may goto zHlx;
}
mode zHlx (m@(4)<=main_dur and buffer+step1-gap1<=water and water<=buffer+step1+step1) {
  rate water:[mininflow-1*lr-1*hr, maxinflow-1*lr-1*hr];
  when !low@(4) (m@(4)>=main_dur and  water<buffer+step0+step0) may goto zHll;
  when !high@(4) (m@(4)>=main_dur and  water>=buffer+step0+step0) may goto zHlH;
  when !high@(3) (m@(4)<main_dur and water>=buffer+step1+step1) may goto zHHx;
  when !low@(2) (m@(4)<main_dur and buffer+step1-gap1>=water) may goto zllx;
  when !off@(2) (m@(4)<main_dur and buffer+step1-gap1>=water) may goto zxlx;
}
mode zxlx (m@(2)<=main_dur and m@(4)<=main_dur and water<=buffer+step2) {
  rate water:[mininflow-1*lr-0*hr, maxinflow-1*lr-0*hr];
  when !low@(2) (m@(2)>=main_dur and  water<buffer+step1) may goto zllx;
  when !high@(2) (m@(2)>=main_dur and  water>=buffer+step1) may goto zHlx;
  when !low@(4) (m@(2)<main_dur and m@(4)>=main_dur and  water<buffer+step1) may goto zxll;
  when !high@(4) (m@(2)<main_dur and m@(4)>=main_dur and  water>=buffer+step1) may goto zxlH;
  when !high@(3) (m@(2)<main_dur and m@(4)<main_dur and water>=buffer+step2) may goto zxHx;
}
mode zlHx (m@(4)<=main_dur and buffer+step1-gap1<=water and water<=buffer+step1+step1) {
  rate water:[mininflow-1*lr-1*hr, maxinflow-1*lr-1*hr];
  when !low@(4) (m@(4)>=main_dur and  water<buffer+step0+step0) may goto zlHl;
  when !high@(4) (m@(4)>=main_dur and  water>=buffer+step0+step0) may goto zlHH;
  when !high@(2) (m@(4)<main_dur and water>=buffer+step1+step1) may goto zHHx;
  when !low@(3) (m@(4)<main_dur and buffer+step1-gap1>=water) may goto zllx;
  when !off@(3) (m@(4)<main_dur and buffer+step1-gap1>=water) may goto zlxx;
}
mode zHHx (m@(4)<=main_dur and buffer+step1+step1-gap1<=water) {
  rate water:[mininflow-0*lr-2*hr, maxinflow-0*lr-2*hr];
  when !low@(4) (m@(4)>=main_dur and  water<buffer+step0+step0+step0) may goto zHHl;
  when !high@(4) (m@(4)>=main_dur and  water>=buffer+step0+step0+step0) may goto zHHH;
  when !low@(3) (m@(4)<main_dur and buffer+step1+step1-gap1>=water) may goto zHlx;
  when !off@(3) (m@(4)<main_dur and buffer+step1+step1-gap1>=water) may goto zHxx;
}
mode zxHx (m@(2)<=main_dur and m@(4)<=main_dur and buffer+step2-gap2<=water) {
  rate water:[mininflow-0*lr-1*hr, maxinflow-0*lr-1*hr];
  when !low@(2) (m@(2)>=main_dur and  water<buffer+step1+step1) may goto zlHx;
  when !high@(2) (m@(2)>=main_dur and  water>=buffer+step1+step1) may goto zHHx;
  when !low@(4) (m@(2)<main_dur and m@(4)>=main_dur and  water<buffer+step1+step1) may goto zxHl;
  when !high@(4) (m@(2)<main_dur and m@(4)>=main_dur and  water>=buffer+step1+step1) may goto zxHH;
  when !low@(3) (m@(2)<main_dur and m@(4)<main_dur and buffer+step2-gap2>=water) may goto zxlx;
  when !off@(3) (m@(2)<main_dur and m@(4)<main_dur and buffer+step2-gap2>=water) may goto zxxx;
}
mode zlxx (m@(3)<=main_dur and m@(4)<=main_dur and water<=buffer+step2) {
  rate water:[mininflow-1*lr-0*hr, maxinflow-1*lr-0*hr];
  when !low@(3) (m@(3)>=main_dur and  water<buffer+step1) may goto zllx;
  when !high@(3) (m@(3)>=main_dur and  water>=buffer+step1) may goto zlHx;
  when !low@(4) (m@(3)<main_dur and m@(4)>=main_dur and  water<buffer+step1) may goto zlxl;
  when !high@(4) (m@(3)<main_dur and m@(4)>=main_dur and  water>=buffer+step1) may goto zlxH;
  when !high@(2) (m@(3)<main_dur and m@(4)<main_dur and water>=buffer+step2) may goto zHxx;
}
mode zHxx (m@(3)<=main_dur and m@(4)<=main_dur and buffer+step2-gap2<=water) {
  rate water:[mininflow-0*lr-1*hr, maxinflow-0*lr-1*hr];
  when !low@(3) (m@(3)>=main_dur and  water<buffer+step1+step1) may goto zHlx;
  when !high@(3) (m@(3)>=main_dur and  water>=buffer+step1+step1) may goto zHHx;
  when !low@(4) (m@(3)<main_dur and m@(4)>=main_dur and  water<buffer+step1+step1) may goto zHxl;
  when !high@(4) (m@(3)<main_dur and m@(4)>=main_dur and  water>=buffer+step1+step1) may goto zHxH;
  when !low@(2) (m@(3)<main_dur and m@(4)<main_dur and buffer+step2-gap2>=water) may goto zlxx;
  when !off@(2) (m@(3)<main_dur and m@(4)<main_dur and buffer+step2-gap2>=water) may goto zxxx;
}
mode zxxx (m@(2)<=main_dur and m@(3)<=main_dur and m@(4)<=main_dur and true) {
  rate water:[mininflow-0*lr-0*hr, maxinflow-0*lr-0*hr];
  when !low@(2) (m@(2)>=main_dur and  water<buffer+step2) may goto zlxx;
  when !high@(2) (m@(2)>=main_dur and  water>=buffer+step2) may goto zHxx;
  when !low@(3) (m@(2)<main_dur and m@(3)>=main_dur and  water<buffer+step2) may goto zxlx;
  when !high@(3) (m@(2)<main_dur and m@(3)>=main_dur and  water>=buffer+step2) may goto zxHx;
  when !low@(4) (m@(2)<main_dur and m@(3)<main_dur and m@(4)>=main_dur and  water<buffer+step2) may goto zxxl;
  when !high@(4) (m@(2)<main_dur and m@(3)<main_dur and m@(4)>=main_dur and  water>=buffer+step2) may goto zxxH;
}

/* automaton turbine */
mode t_low (true) {
  rate m:0; 
  when ?high (true) may c = c+1; goto t_high;
}
mode t_high (true) {
  rate m:0; 
  when ?low (c <main_thr) may goto t_low;
  when ?off (c>=main_thr) may goto t_maintenance;
}
mode t_maintenance (m<=main_dur) {
  rate m:1; 
  when ?low (m>=main_dur) may c = 0; m = 0; goto t_low;
  when ?high (m>=main_dur) may c = 0; m = 0; goto t_high;
}

initially 
zlll@(1) && buffer<water@(1) && water@(1)<buffer+step0 
  && forall p:2..#PS, (t_low@(p) && c@(p)==0 && m@(p)==0);

